/*
 *	$Id: objc-stdio.m,v 1.3 2006/03/16 20:41:20 rh Exp $
 */
#import <Foundation/Foundation.h>

#define ENC NSUTF8StringEncoding

int main (int argc, const char *argv[])
{
	NSAutoreleasePool *pool = [NSAutoreleasePool new];
	NSFileHandle *in  = [NSFileHandle fileHandleWithStandardInput];
	NSFileHandle *out = [NSFileHandle fileHandleWithStandardOutput];
	NSData *data;
	
	while ((data = [in availableData]) != nil)
	{
		NSAutoreleasePool *innerpool = [NSAutoreleasePool new];
		NSString *input = [[NSString alloc] initWithData: data
							encoding: ENC];
		NSArray *lines = [input componentsSeparatedByString: @"\n"];
		int n = [lines count];
		int i;

		if (--n < 1) break;	/* end of file? */
		
		[out writeData: [[NSString stringWithFormat:
					     @"Got %d lines:\n", n]
			dataUsingEncoding: ENC]];
		
		for (i = 0; i < n; i++)
			[out writeData: [[NSString stringWithFormat: @"<%@>\n",
				[lines objectAtIndex: i]]
				dataUsingEncoding: ENC]];
		
		[input release];
		[innerpool release];
	}

	[pool release];

	return 0;
}
